## clblas 2.6

=== src/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

cmake_minimum_required(VERSION 2.8)

#User toggle-able options that can be changed on the command line with -D
option( BUILD_RUNTIME "Build the BLAS runtime library" ON )
option( BUILD_TEST "Build the library testing suite (dependency on google test, Boost, and ACML)" ON )
option( BUILD_PERFORMANCE "Copy the performance scripts that can measure and graph performance" OFF )
option( BUILD_SAMPLE "Build the sample programs" OFF )
option( BUILD_CLIENT "Build a command line clBLAS client program with a variety of configurable parameters (dependency on Boost)" OFF )
option( BUILD_KTEST "A command line tool for testing single clBLAS kernel" ON )
option( BUILD_SHARED_LIBS "Build shared libraries" ON )

#enable or disable offline compilation for different devices. Currently only Hawaii, Bonaire, Tahiti have the option.
option( OCL_OFFLINE_BUILD_HAWAII_KERNEL "Offline compile the OpenCL kernels for Hawaii device" OFF)
option( OCL_OFFLINE_BUILD_BONAIRE_KERNEL "Offline compile the OpenCL kernels for Bonaire device" OFF)
option( OCL_OFFLINE_BUILD_TAHITI_KERNEL "Offline compile the OpenCL kernels for Tathit device" OFF)

if( (OCL_OFFLINE_BUILD_HAWAII_KERNEL AND OCL_OFFLINE_BUILD_BONAIRE_KERNEL) OR (OCL_OFFLINE_BUILD_HAWAII_KERNEL AND OCL_OFFLINE_BUILD_TAHITI_KERNEL) OR (OCL_OFFLINE_BUILD_BONAIRE_KERNEL AND OCL_OFFLINE_BUILD_TAHITI_KERNEL))
   MESSAGE( WARNING "More than one device is chosen for offline compilation of static kernels. This might result in running out of heap memory with certain driver. Please consider offline compliation for ONE device only." )
endif( )

if( NOT OCL_OFFLINE_BUILD_HAWAII_KERNEL )
  #use dynamic generated kernels
  MESSAGE(STATUS "Build dynamic Hawaii kernels.")
  MESSAGE(STATUS "Check OCL_OFFLINE_BUILD_HAWAII_KERNEL to build kernls at compile-time. This will eliminates clBuildProgram() overhead and better kernel performance with certain driver.")
  add_definitions(-DCLBLAS_HAWAII_DYNAMIC_KERNEL) 
else()
  MESSAGE(STATUS "Build static Hawaii kernels.")
  MESSAGE(STATUS "Uncheck OCL_OFFLINE_BUILD_HAWAII_KERNEL to build kernls at run-time")
  MESSAGE(STATUS "Please ensure the presence of Hawaii device in the system. With certain driver/compiler flags, this might result in compile-time error.")  
endif( )

if( NOT OCL_OFFLINE_BUILD_BONAIRE_KERNEL )
  #use dynamic generated kernels
  MESSAGE(STATUS "Build dynamic Bonaire kernels.")
  MESSAGE(STATUS "Check OCL_OFFLINE_BUILD_BONAIRE_KERNEL to build kernls at compile-time. This will eliminates clBuildProgram() overhead and better kernel performance with certain driver.")
  add_definitions(-DCLBLAS_BONAIRE_DYNAMIC_KERNEL) 
else()
  MESSAGE(STATUS "Build static Bonaire kernels.")
  MESSAGE(STATUS "Uncheck OCL_OFFLINE_BUILD_BONAIRE_KERNEL to build kernls at run-time")
  MESSAGE(STATUS "Please ensure the presence of Bonaire device in the system. With certain driver/compiler flags, this might result in compile-time error.")    
endif( )

if( NOT OCL_OFFLINE_BUILD_TAHITI_KERNEL )
  #use dynamic generated kernels
  MESSAGE(STATUS "Build dynamic Tahiti kernels.")
  MESSAGE(STATUS "Check OCL_OFFLINE_BUILD_TAHITI_KERNEL to build kernls at compile-time. This will eliminates clBuildProgram() overhead and better kernel performance with certain driver.")
  add_definitions(-DCLBLAS_TAHITI_DYNAMIC_KERNEL) 
else( )
  MESSAGE(STATUS "Build static Tahiti kernels.")
  MESSAGE(STATUS "Uncheck OCL_OFFLINE_BUILD_TAHITI_KERNEL to build kernls at run-time")
  MESSAGE(STATUS "Please ensure the presence of Tahiti device in the system. With certain driver/compiler flags, this might result in compile-time error.")    
endif( )


# Ask the user to verify compiler version. If OpenCL 2.0 is supported. Certain public flags can be user
set( OCL_VERSION "1.2" CACHE STRING "The version of OpenCL supported by your driver/device" )
set_property( CACHE OCL_VERSION PROPERTY STRINGS 2.0 1.2 1.1 )
message( STATUS "You have confirmed OpenCL ${OCL_VERSION} is supported in your system" )

# By default test-correctness is linked and tested against ACML library.
# However, test-correctness can instead use NETLIB as a reference library
# On Mac OSX systems, this must be set to OFF for the build to succeed (due to nesting of FindBLAS code)
if ( APPLE )
	set(CORR_TEST_WITH_ACML OFF CACHE BOOL "Use ACML library in correctness tests")
else ( )
	message(STATUS "CORR_TEST_WITH_ACML set to ON")
	set(CORR_TEST_WITH_ACML ON CACHE BOOL "Use ACML library in correctness tests")
endif( )

if( CMAKE_GENERATOR MATCHES "NMake" )
  option( NMAKE_COMPILE_VERBOSE "Print compile and link strings to the console" OFF )
  if( NMAKE_COMPILE_VERBOSE )
    set( CMAKE_START_TEMP_FILE "" )
    set( CMAKE_END_TEMP_FILE "" )
    set( CMAKE_VERBOSE_MAKEFILE 1 )
  endif( )
endif( )

# If we are on linux, and we wish to link with the netlib BLAS implementation, we need to have a valid fortran compiler
if( NOT CORR_TEST_WITH_ACML AND NOT WIN32 AND NOT APPLE )
  project(clBLAS Fortran C CXX )
else( )
  project(clBLAS C CXX)
endif( )

# Define a version for the code
if( NOT DEFINED clBLAS_VERSION_MAJOR )
    set( clBLAS_VERSION_MAJOR 2 )
endif( )

if( NOT DEFINED clBLAS_VERSION_MINOR )
    set( clBLAS_VERSION_MINOR 6 )
endif( )

if( NOT DEFINED clBLAS_VERSION_PATCH )
    set( clBLAS_VERSION_PATCH 0 )
endif( )

set( clBLAS_VERSION "${clBLAS_VERSION_MAJOR}.${clBLAS_VERSION_MINOR}.${clBLAS_VERSION_PATCH}")

# Increment this if we break backward compatibility.
set( clBLAS_SOVERSION 2 )

# We have custom written Find* modules now in the root source directory
set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR} )

# On windows, it's convenient to change the default install prefix such that it does NOT point to 'program files' (permissions problems)
# Need to check out CMAKE_RUNTIME_OUTPUT_DIRECTORY variable, and see if that eliminates the need to modify install path
if( WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT )
	set( CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}/package" CACHE PATH "Install path prefix, prepended onto install directories" FORCE )
endif( )

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif()

# These variables are meant to contain string which should be appended to the installation paths 
# of library and executable binaries, respectively.  They are meant to be user configurable/overridable.  
set( SUFFIX_LIB_DEFAULT "" )
set( SUFFIX_BIN_DEFAULT "" )

if(TARGET_PLATFORM EQUAL 32 OR TARGET_PLATFORM EQUAL 64)
    set(TARGET_PLATFORM ${TARGET_PLATFORM} CACHE STRING "Target platform type (32-bit or 64-bit)" FORCE)
else()
    if(CMAKE_SIZEOF_VOID_P MATCHES 8)
        set(TARGET_PLATFORM "64" CACHE STRING "Target platform type (32-bit or 64-bit)" FORCE)
    else()
        set(TARGET_PLATFORM "32" CACHE STRING "Target platform type (32-bit or 64-bit)" FORCE)
    endif()
endif()

message(STATUS "Target platform: ${TARGET_PLATFORM}-bit")
if(TARGET_PLATFORM EQUAL 32)
    set(_arch "x86" INTERNAL)
    set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS FALSE)
else()
    set(_arch "x86_64" INTERNAL)
    set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE)
    if( NOT APPLE )
        set( SUFFIX_LIB_DEFAULT "64" )
    endif( )
endif()

set( SUFFIX_LIB ${SUFFIX_LIB_DEFAULT} CACHE STRING "String to append to 'lib' install path" )
set( SUFFIX_BIN ${SUFFIX_BIN_DEFAULT} CACHE STRING "String to append to 'bin' install path" )

if( MSVC_IDE )
    set_property( GLOBAL PROPERTY USE_FOLDERS TRUE )
endif( )

# add the math library for Linux
if( UNIX ) 
    set(MATH_LIBRARY "m")
endif()

# set the path to specific OpenCL compiler
set( OCL_COMPILER_DIR "OPENCL COMPILER PATH" CACHE PATH "OPENCL COMPILER PATH")
if ( ${OCL_COMPILER_DIR} STREQUAL "OPENCL COMPILER PATH")
    message( STATUS "Use default OpenCL Compiler")
	  set(ENV_PATH "$ENV{PATH}")
else ()
    message( STATUS "OPENCL COMPILER: ${OCL_COMPILER_DIR}")
	if(UNIX)
	  set(ENV_PATH "${OCL_COMPILER_DIR}")
	else()
	  set(ENV_PATH "${OCL_COMPILER_DIR}")
	endif()
endif()

# Find the BLAS library
# TODO: maybe this could be written using the FindBLAS module in the future
if( BUILD_TEST )
	if(NOT CORR_TEST_WITH_ACML)
	    if(APPLE)
			find_library(BLAS_LIBRARIES Accelerate HINTS /System/Library/Frameworks/Accelerate.framework)
		       	MARK_AS_ADVANCED(BLAS_LIBRARIES)
		       	message(STATUS "Using Accelerate framework on Mac OS-X")
	    else()
			find_package( Netlib COMPONENTS BLAS REQUIRED )
        endif()
		else( )
		# Find ACML BLAS implementation
		# platform dependent ACML subdirectory
		if (WIN32)
			set(ACML_SUBDIR ifort${TARGET_PLATFORM}_mp)
		else()
		   set(ACML_SUBDIR gfortran${TARGET_PLATFORM}_mp)
		endif()

		find_path(ACML_INCLUDE_DIRS acml.h
			HINTS
				${ACML_ROOT}/include
				${ACML_ROOT}/${ACML_SUBDIR}/include
				$ENV{ACML_ROOT}/include
                                $ENV{ACML_ROOT}/${ACML_SUBDIR}/include
		)

		if( ACML_INCLUDE_DIRS )
		else()
			message(WARNING "Cannot find acml.h")
		endif()
		
		if( UNIX )
			find_library(ACML_LIBRARIES acml_mp
				HINTS
					${ACML_ROOT}/lib
					${ACML_ROOT}/${ACML_SUBDIR}/lib
					$ENV{ACML_ROOT}/lib
                                        $ENV{ACML_ROOT}/${ACML_SUBDIR}/lib
			)
			find_library(_acml_mv_library acml_mv
				HINTS
					${ACML_ROOT}/lib
					${ACML_ROOT}/${ACML_SUBDIR}/lib
					$ENV{ACML_ROOT}/lib
                                        $ENV{ACML_ROOT}/${ACML_SUBDIR}/lib
			)
			mark_as_advanced(_acml_mv_library)
		endif( )
		
		if(WIN32)
			find_library(ACML_LIBRARIES libacml_mp_dll
				HINTS
					${ACML_ROOT}/lib
					${ACML_ROOT}/${ACML_SUBDIR}/lib
					$ENV{ACML_ROOT}/lib
                                        $ENV{ACML_ROOT}/${ACML_SUBDIR}/lib
			)
		endif( )
		
		if( NOT ACML_LIBRARIES )
			message(WARNING "Cannot find libacml")
		endif( )

		if(ACML_INCLUDE_DIRS AND ACML_LIBRARIES)
			if(_acml_mv_library)
				list(APPEND ACML_LIBRARIES ${_acml_mv_library})
			endif()
			message(STATUS "Found ACML: ${ACML_LIBRARIES}")
			set(ACML_FOUND TRUE BOOL "Found the ACML package")
		endif()
		mark_as_advanced(ACML_FOUND ACML_INCLUDE_DIRS ACML_LIBRARIES)

	endif( )
endif( )

# This will define OPENCL_FOUND
find_package( OpenCL )

# Find Boost on the system, and configure the type of boost build we want
set( Boost_USE_MULTITHREADED ON )
set( Boost_USE_STATIC_LIBS   ON )
set( Boost_DETAILED_FAILURE_MSG   ON )
set( Boost_DEBUG ON )
set( Boost_ADDITIONAL_VERSIONS "1.44.0" "1.44" "1.47.0" "1.47" )

find_package( Boost 1.33.0 COMPONENTS program_options )
message(STATUS "Boost_PROGRAM_OPTIONS_LIBRARY: ${Boost_PROGRAM_OPTIONS_LIBRARY}")


if( NOT Boost_FOUND )
	message( STATUS "The clBLAS ktest requires boost to be installed" )
	set( BUILD_KTEST OFF )
	message( STATUS "The clBLAS client requires boost to be installed" )
	set( BUILD_CLIENT OFF )
endif()

# Turn on maximum compiler verbosity
if(CMAKE_COMPILER_IS_GNUCXX)
    add_definitions(-pedantic -Wall -Wextra
        -D_POSIX_C_SOURCE=199309L -D_XOPEN_SOURCE=500
    )
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -Wstrict-prototypes" CACHE STRING
        "Default CFLAGS" FORCE)
    # Don't use -rpath.

=== src/library/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

set(SRC_BLAS
    blas/init.c
    blas/impl.c
    blas/scimage.c
    blas/xgemv.c
    blas/xsymv.c
    blas/xgemm.cc
    blas/xtrmm.c
    blas/xtrsm.cc
    blas/xsyrk.c
    blas/xsyr2k.c
    blas/xtrmv.c
    blas/xtrsv.c
    blas/xsymm.c
    blas/xgemm2.c
    blas/xger.c
    blas/xsyr.c
    blas/xsyr2.c
    blas/xher.c
    blas/xher2.c
    blas/xhemv.c
    blas/xhemm.c
    blas/xherk.c
    blas/xhpmv.c
    blas/xspmv.c
    blas/xgbmv.c
    blas/xtbmv.c
    blas/xshbmv.c
    blas/xtbsv.c
    blas/xher2k.c
    blas/xswap.c
    blas/xscal.cc
    blas/xcopy.c
    blas/xaxpy.c
    blas/xdot.c
    blas/xrotg.c
    blas/xrotmg.c
    blas/xrot.c
    blas/xrotm.c
    blas/ixamax.c
    blas/xnrm2.c
    blas/xasum.c
    blas/matrix.c
    blas/fill.cc
    blas/functor/functor.cc
    blas/functor/functor_selector.cc
    blas/functor/functor_xgemm.cc
    blas/functor/functor_xscal.cc
    blas/functor/functor_xtrsm.cc
    blas/functor/functor_xscal_generic.cc
    blas/functor/tahiti.cc
    blas/functor/hawaii.cc
	blas/functor/bonaire.cc
    blas/functor/gcn_dgemm.cc
    blas/functor/gpu_dtrsm.cc
    blas/functor/gpu_dtrsm192.cc
    blas/functor/functor_fill.cc
	blas/functor/hawaii_dgemmChannelConflict.cc
	blas/functor/hawaii_dgemmSplitKernel.cc
	blas/functor/hawaii_sgemmSplitKernel.cc
	blas/functor/hawaii_sgemmSplit64_32.cc
	blas/functor/gcn_dgemmCommon.cc
	blas/functor/gcn_sgemm.cc
	blas/functor/gcn_zgemm.cc
	blas/functor/gcn_dgemmSmallMatrices.cc
	blas/functor/gcn_sgemmSmallMatrices.cc
	blas/functor/hawaii_sgemmBranchKernel.cc
)

set(SRC_BLAS_HEADERS
    blas/include/blas_funcs.h
    blas/include/matrix_dims.h
    blas/include/matrix_props.h
    blas/include/blas_mempat.h
    blas/include/clblas-internal.h
    blas/include/solution_seq.h
    blas/include/events.h
    blas/functor/include/functor.h
    blas/functor/include/functor_xgemm.h
    blas/functor/include/functor_xscal.h
    blas/functor/include/functor_xtrsm.h
    blas/functor/include/functor_xscal_generic.h
    blas/functor/include/functor_selector.h
    blas/functor/include/tahiti.h
    blas/functor/include/hawaii.h
	blas/functor/include/bonaire.h
    blas/functor/include/gcn_dgemm.h
    blas/functor/include/gpu_dtrsm.h
    blas/functor/include/gpu_dtrsm192.h
    blas/functor/include/BinaryBuild.h
	blas/functor/include/hawaii_dgemmChannelConflict.h
	blas/functor/include/hawaii_dgemmSplitKernel.h
	blas/functor/include/hawaii_sgemmSplitKernel.h
	blas/functor/include/hawaii_sgemmSplit64_32.h
	blas/functor/include/gcn_dgemmCommon.h
	blas/functor/include/gcn_sgemm.h
	blas/functor/include/gcn_zgemm.h
	blas/functor/include/gcn_dgemmSmallMatrices.h
	blas/functor/include/gcn_sgemmSmallMatrices.h
	blas/functor/include/hawaii_sgemmBranchKernel.h
)

set(SRC_BLAS_GENERIC
    blas/generic/common.c
    blas/generic/common2.cc
    blas/generic/blas_funcs.c
    blas/generic/events.c
    blas/generic/matrix_props.c
    blas/generic/matrix_dims.c
    blas/generic/kdump.c
    blas/generic/solution_assert.c
    blas/generic/solution_seq.c
    blas/generic/solution_seq_make.c
    blas/generic/problem_iter.c
    blas/generic/kernel_extra.c
    blas/generic/binary_lookup.cc
    blas/generic/functor_cache.cc
)

set(SRC_BLAS_GENS
    blas/gens/gen_init.c
    blas/gens/blas_kgen.c
    blas/gens/blas_subgroup.c
    blas/gens/gen_helper.c
    blas/gens/tilemul.c
    blas/gens/fetch.c
    blas/gens/tile.c
    blas/gens/tile_iter.c
    blas/gens/decomposition.c
    blas/gens/gemv.c
    blas/gens/symv.c
    blas/gens/gemm.c
    blas/gens/trmm.c
    blas/gens/trsm.c
    blas/gens/syrxk.c
    blas/gens/trxm_common.c
    blas/gens/trsm_kgen.c
    blas/gens/xxmv_common.c
    blas/gens/legacy/blas_kgen_legacy.c
    blas/gens/legacy/gen_helper_legacy.c
    blas/gens/legacy/trxm_common_legacy.c
    blas/gens/legacy/trsm_kgen_legacy.c
    blas/gens/legacy/blkmul.c
    blas/gens/legacy/gemm_lds.c
    blas/gens/legacy/gemm_img.c
    blas/gens/legacy/trmm_lds.c
    blas/gens/legacy/trmm_img.c
    blas/gens/legacy/trsm_lds.c
    blas/gens/legacy/trsm_img.c
    blas/gens/legacy/trsm_cached_lds.c
    blas/gens/trmv_reg.cpp
    blas/gens/ger_lds.cpp
    blas/gens/trsv_trtri.cpp
    blas/gens/trsv_gemv.cpp
    blas/gens/kprintf.cpp
    blas/gens/syr_lds.cpp
    blas/gens/her_lds.cpp
    blas/gens/syr2_lds.cpp
    blas/gens/her2_lds.cpp
    blas/gens/symm_cached.cpp
    blas/gens/gemm_cached.cpp
    blas/gens/gemm_tail_cached.cpp
    blas/gens/gbmv.cpp
    blas/gens/tuned_numbers.c
    blas/gens/swap_reg.cpp
    blas/gens/scal_reg.cpp
    blas/gens/copy_reg.cpp
    blas/gens/axpy_reg.cpp
    blas/gens/dot.cpp
    blas/gens/reduction.cpp
    blas/gens/rotg_reg.cpp
    blas/gens/rotmg_reg.cpp
    blas/gens/rotm_reg.cpp
    blas/gens/iamax.cpp
    blas/gens/nrm2.cpp
    blas/gens/asum.cpp
)

#set (BIN_CL_TEMPLATES
#dgemm_hawai.cl
#dtrsm_gpu.cl
#)

set (SRC_CL_TEMPLATES
    gemm.cl
    gemm_helper.cl
    gbmv.cl
    ger.cl
    her.cl
    symm_helper.cl
    syr2_her2.cl
    syr_her.cl
    trsv.cl
    her2.cl
    symm.cl
    syr2.cl
    syr.cl
    trmv.cl
    trsv_gemv.cl
    swap.cl
    scal.cl
    copy.cl
    axpy.cl
    dot.cl
    reduction.cl
    rotg.cl
    rotmg.cl
    rotm.cl
    iamax.cl
    nrm2.cl
    asum.cl
    custom_gemm.cl
    dgemm_hawai.cl
	dgemm_hawaiiChannelConfilct.cl
	dgemm_hawaiiSplitKernel.cl
	sgemm_hawaiiSplitKernel.cl
    dtrsm_gpu.cl
    dtrsm_gpu192.cl
	dgemm_gcn_SmallMatrices.cl
	sgemm_gcn_SmallMatrices.cl
	sgemm_gcn.cl
	zgemm_gcn.cl
)

set(SRC_CL_TEMPLATES_GEN
    dgemm_hawai.clHawaii_64.bin.cl
    dtrsm_gpu.clHawaii_64.bin.cl
	dtrsm_gpu192.clHawaii_64.bin.cl
	dgemm_hawaiiChannelConfilct.clHawaii_64.bin.cl
	dgemm_hawaiiSplitKernel.clHawaii_64.bin.cl
	sgemm_hawaiiSplitKernel.clHawaii_64.bin.cl	
	sgemm_hawaiiSplitKernel.clBonaire_64.bin.cl	
    dgemm_hawai.clTahiti_64.bin.cl
    dtrsm_gpu.clTahiti_64.bin.cl
	dgemm_gcn_SmallMatrices.clHawaii_64.bin.cl
	dgemm_gcn_SmallMatrices.clTahiti_64.bin.cl
	sgemm_gcn_SmallMatrices.clHawaii_64.bin.cl
	sgemm_gcn_SmallMatrices.clTahiti_64.bin.cl
    sgemm_gcn_SmallMatrices.clBonaire_64.bin.cl
	sgemm_gcn.clHawaii_64.bin.cl
	zgemm_gcn.clHawaii_64.bin.cl
    sgemm_gcn.clBonaire_64.bin.cl
	sgemm_gcn.clTahiti_64.bin.cl
	sgemm_hawaiiSplit64_32.clHawaii_64.bin.cl
)

set(SRC_BLAS_GENERIC_HEADERS
    blas/generic/solution_assert.h
    blas/generic/problem_iter.h
)

set(SRC_BLAS_GENS_HEADERS
    blas/gens/fetch.h
    blas/gens/blas_kgen.h
    blas/gens/blas_subgroup.h
    blas/gens/gen_helper.h
    blas/gens/init.h
    blas/gens/trxm_common.h
    blas/gens/trsm_kgen.h
    blas/gens/xxmv_common.h
    blas/gens/tile.h
    blas/gens/tile_iter.h
    blas/gens/tuned_numbers.h
)

set(SRC_COMMON
    common/list.c
    common/clkern.c
    common/kern_cache.c
    common/kerngen_core.c
    common/kgen_basic.c
    common/kgen_loop_helper.c
    common/kgen_guard.c
    common/misc.c
    common/devinfo.c
    common/devinfo-cache.c
    common/mutex.c
    common/rwlock.c
    common/trace_malloc.c
    common/md5sum.c
)

set(SRC_COMMON_GENS
    common/gens/dblock_kgen.c
)

set(SRC_TOOLS
    tools/tune/toolslib.c
    tools/tune/fileio.c
    tools/tune/dimension.c
    tools/tune/storage_init.c
    tools/tune/storage_io.c
    tools/tune/storage_data.c
)

set(CLBLAS_SOURCES
    ${SRC_COMMON} ${SRC_COMMON_GENS} ${SRC_BLAS} ${SRC_BLAS_GENERIC}
    ${SRC_BLAS_GENS} ${SRC_TOOLS} ../clBLAS.def
)
set(GLOBAL_HEADERS
    ${clBLAS_SOURCE_DIR}/clBLAS.h
    ${clBLAS_SOURCE_DIR}/clBLAS-complex.h 
    ${clBLAS_SOURCE_DIR}/include/clkern.h
    ${clBLAS_SOURCE_DIR}/include/cltypes.h
    ${clBLAS_SOURCE_DIR}/include/dblock_kgen.h
    ${clBLAS_SOURCE_DIR}/include/defbool.h
    ${clBLAS_SOURCE_DIR}/include/devinfo.h
    ${clBLAS_SOURCE_DIR}/include/dis_warning.h
    ${clBLAS_SOURCE_DIR}/include/kern_cache.h
    ${clBLAS_SOURCE_DIR}/include/kernel_extra.h
    ${clBLAS_SOURCE_DIR}/include/kerngen.h
    ${clBLAS_SOURCE_DIR}/include/list.h
    ${clBLAS_SOURCE_DIR}/include/mempat.h
    ${clBLAS_SOURCE_DIR}/include/msvc.h
    ${clBLAS_SOURCE_DIR}/include/mutex.h
    ${clBLAS_SOURCE_DIR}/include/rwlock.h
    ${clBLAS_SOURCE_DIR}/include/solver.h
    ${clBLAS_SOURCE_DIR}/include/md5sum.h
    ${clBLAS_SOURCE_DIR}/include/binary_lookup.h
)

source_group(common FILES ${SRC_COMMON})
source_group(common\\gens FILES ${SRC_COMMON_GENS})
source_group(blas FILES ${SRC_BLAS})
source_group(blas\\include FILES ${SRC_BLAS_HEADERS})
source_group(blas\\generic FILES ${SRC_BLAS_GENERIC})
source_group(blas\\gens FILES ${SRC_BLAS_GENS}
    ${SRC_BLAS_GENS_HEADERS})

include_directories(${OPENCL_INCLUDE_DIRS}
    ${clBLAS_SOURCE_DIR}
    ${clBLAS_SOURCE_DIR}/include
    ${clBLAS_SOURCE_DIR}/library/blas/include
    ${clBLAS_SOURCE_DIR}/library/blas/functor/include
    ${clBLAS_SOURCE_DIR}/library/tools/tune
    ${clBLAS_BINARY_DIR}/include
)

option( BLAS_DUMP_CLBLAS_KERNELS "Force the library to dump OpenCL kernels to disk" OFF )
if( BLAS_DUMP_CLBLAS_KERNELS )
    add_definitions( -DDUMP_CLBLAS_KERNELS )
endif()

option( BLAS_KEEP_KERNEL_SOURCES "Prevent the library from stripping source from kernels" OFF )
if( BLAS_KEEP_KERNEL_SOURCES )
    add_definitions( -DKEEP_CLBLAS_KERNEL_SOURCES )
endif()

option( BLAS_TRACE_MALLOC "Simple functionality to track memory leaks" OFF )
if( BLAS_TRACE_MALLOC )
    add_definitions( -DTRACE_MALLOC )
endif()

option( BLAS_PRINT_BUILD_ERRORS "Enable printing of OpenCL compiler errors on stdout" ON )
if( BLAS_PRINT_BUILD_ERRORS )
    add_definitions( -DPRINT_BUILD_ERRORS )
endif()

include( ExternalProject )
ExternalProject_Add( tplgen
    URL "${CMAKE_SOURCE_DIR}/library/tools/tplgen"
    INSTALL_COMMAND ""
)

# if offline compilation is not chosen, bingen should not be built
if(OCL_OFFLINE_BUILD_TAHITI_KERNEL OR OCL_OFFLINE_BUILD_HAWAII_KERNEL OR OCL_OFFLINE_BUILD_BONAIRE_KERNEL)
	ExternalProject_Add( bingen
		URL "${CMAKE_SOURCE_DIR}/library/tools/bingen"
		CMAKE_ARGS -DOPENCL_LIBRARIES=${OPENCL_LIBRARIES} -DOPENCL_INCLUDE_DIRS=${OPENCL_INCLUDE_DIRS}
		INSTALL_COMMAND ""
	)
endif()

message(STATUS "OCL_VERSION = ${OCL_VERSION}")
if( OCL_VERSION STREQUAL "2.0")
	if(EXISTS ${CMAKE_SOURCE_DIR}/flags.txt)
		MESSAGE(STATUS "flags.txt found. will load AMD_OCL_BUILD_OPTIONS_APPEND from it.")
		set (LOAD_CL_FLAGS TRUE)
		file (STRINGS "${CMAKE_SOURCE_DIR}/flags.txt" OCL_FLAGS)
		MESSAGE(STATUS "OCLFLAGS: ${OCL_FLAGS}")
		string(REPLACE "OCL " "OCL;" OCL_FLAGS_REPLACED ${OCL_FLAGS})
		list(GET OCL_FLAGS_REPLACED 1 OCL_FLAGS_REPLACED_1)#flags for TAHITI
		list(GET OCL_FLAGS_REPLACED 3 OCL_FLAGS_REPLACED_3)#flags for HAWAII 1
		list(GET OCL_FLAGS_REPLACED 5 OCL_FLAGS_REPLACED_5)#flags for HAWAII 2
		list(GET OCL_FLAGS_REPLACED 7 OCL_FLAGS_REPLACED_7)#flags for BONAIRE
		#MESSAGE("${OCL_FLAGS_REPLACED_7}")
	elseif(EXISTS ${CMAKE_SOURCE_DIR}/flags_public.txt)
		MESSAGE(STATUS "flags_public.txt found. will load AMD_OCL_BUILD_OPTIONS_APPEND from it.")
		set (LOAD_CL_FLAGS TRUE)
		file (STRINGS "${CMAKE_SOURCE_DIR}/flags_public.txt" OCL_FLAGS)
		MESSAGE(STATUS "OCLFLAGS: ${OCL_FLAGS}")
		string(REPLACE "OCL " "OCL;" OCL_FLAGS_REPLACED ${OCL_FLAGS})
		list(GET OCL_FLAGS_REPLACED 1 OCL_FLAGS_REPLACED_1)#flags for TAHITI
		list(GET OCL_FLAGS_REPLACED 3 OCL_FLAGS_REPLACED_3)#flags for HAWAII 1

=== debian/changelog ===
clblas (2.6-2) unstable; urgency=medium

  * d/control: remove ${shlibs:Depends} substitution from debug package
  * d/*-dev.install: use more generic expressions
  * d/rules: use stricter hardening
  * d/p: add patch to use Boost dynamic libraries
  * d/p: add patch fixing missing inclusion of stdlib

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 18 Aug 2015 19:55:19 +0100

clblas (2.6-1) unstable; urgency=medium

  * New upstream release.
  * d/patches: add patch fixing missing linkage with pthread.
  * Break fix-doxygen-settings.patch down to more specific patches:
    - fix-docs-output.patch,
    - use-system-mathjax.patch,
    - reproducible-build.patch.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 30 Jul 2015 17:29:37 +0100

clblas (2.4-3) unstable; urgency=medium

  * Add gbp.conf file.
  * Allow build with alternative OpenCL implementation. 

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 30 Jul 2015 11:49:05 +0100

=== debian/control ===
Source: clblas
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Build-Depends: cmake,
               debhelper (>= 9),
               doxygen,
               libboost-program-options-dev,
               ocl-icd-opencl-dev | opencl-dev
Standards-Version: 3.9.6
Homepage: https://github.com/clMathLibraries/clBLAS
Vcs-Git: git://anonscm.debian.org/debian-science/packages/clblas.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/clblas.git

Package: libclblas-bin
Multi-Arch: foreign
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libclblas2 (= ${binary:Version})
Description: OpenCL BLAS library (executables)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS executables.

Package: libclblas-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libclblas2 (= ${binary:Version})
Suggests: libclblas-doc
Description: OpenCL BLAS library (development files)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS development files.

Package: libclblas-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
         libjs-jquery,
         libjs-mathjax
Description: OpenCL BLAS library (documentation)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS documentation.

Package: libclblas2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends} 
Pre-Depends: ${misc:Pre-Depends}
Description: OpenCL BLAS library (shared library)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS shared library.

Package: libclblas2-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         libclblas2 (= ${binary:Version})
Description: OpenCL BLAS library (debugging symbols)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --sourcedirectory=src \
		--buildsystem=cmake \
		--parallel \
		--dbg-package=libclblas2-dbg

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DBUILD_RUNTIME=ON \
		-DBUILD_TEST=OFF \
		-DBUILD_PERFORMANCE=OFF \
		-DBUILD_SAMPLE=OFF \
		-DBUILD_CLIENT=ON \
		-DBUILD_KTEST=OFF \
		-DBUILD_SHARED_LIBS=ON \

override_dh_auto_build:
	dh_auto_build
	echo "I: Generating Doxygen documentation"
	cd doc/ && doxygen clBLAS.doxy && rm html/jquery.js

override_dh_auto_clean:
	dh_auto_clean
	$(RM) -f doc/doxygen_sqlite3.db
	$(RM) -rf doc/html

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/clBLAS-$1\.tar\.gz/ \
  https://github.com/clMathLibraries/clBLAS/tags .*/v?(\d\S*)\.tar\.gz
